// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	srand( (unsigned)time( NULL ) );
	
	init = 0;
}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_PERCENTCTRL1, Percent1);
	DDX_Control(pDX, IDC_PERCENTCTRL10, Percent10);
	DDX_Control(pDX, IDC_PERCENTCTRL11, Percent11);
	DDX_Control(pDX, IDC_PERCENTCTRL12, Percent12);
	DDX_Control(pDX, IDC_PERCENTCTRL2, Percent2);
	DDX_Control(pDX, IDC_PERCENTCTRL3, Percent3);
	DDX_Control(pDX, IDC_PERCENTCTRL4, Percent4);
	DDX_Control(pDX, IDC_PERCENTCTRL5, Percent5);
	DDX_Control(pDX, IDC_PERCENTCTRL6, Percent6);
	DDX_Control(pDX, IDC_PERCENTCTRL7, Percent7);
	DDX_Control(pDX, IDC_PERCENTCTRL8, Percent8);
	DDX_Control(pDX, IDC_PERCENTCTRL9, Percent9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
		}
	else {
		CDialog::OnPaint();
		}

	if (!init) {
		init = 1;

		SetTimer(1000,55,NULL);
		SetTimer(1010,55,NULL);
		}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL1, -601 /* DblClick */, OnDblClickPercentctrl1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL10, -601 /* DblClick */, OnDblClickPercentctrl10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL11, -601 /* DblClick */, OnDblClickPercentctrl11, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL12, -601 /* DblClick */, OnDblClickPercentctrl12, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL2, -601 /* DblClick */, OnDblClickPercentctrl2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL3, -601 /* DblClick */, OnDblClickPercentctrl3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL4, -601 /* DblClick */, OnDblClickPercentctrl4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL5, -601 /* DblClick */, OnDblClickPercentctrl5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL6, -601 /* DblClick */, OnDblClickPercentctrl6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL7, -601 /* DblClick */, OnDblClickPercentctrl7, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL8, -601 /* DblClick */, OnDblClickPercentctrl8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL9, -601 /* DblClick */, OnDblClickPercentctrl9, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL8, 1 /* Change */, OnChangePercentctrl8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL9, 1 /* Change */, OnChangePercentctrl9, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL10, 1 /* Change */, OnChangePercentctrl10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL11, 1 /* Change */, OnChangePercentctrl11, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_PERCENTCTRL12, 1 /* Change */, OnChangePercentctrl12, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CVCDemoDlg::OnDblClickPercentctrl1() 
{
	Percent1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl10() 
{
	Percent10.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl11() 
{
	Percent11.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl12() 
{
	Percent12.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl2() 
{
	Percent2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl3() 
{
	Percent3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl4() 
{
	Percent4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl5() 
{
	Percent5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl6() 
{
	Percent6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl7() 
{
	Percent7.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl8() 
{
	Percent8.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickPercentctrl9() 
{
	Percent9.ShowPropertyPage();
}

void CVCDemoDlg::OnChangePercentctrl8() 
{
	Percent9.SetPortionPercent(Percent8.GetPortionPercent());
	Percent10.SetPortionPercent(Percent8.GetPortionPercent());
	Percent11.SetPortionPercent(Percent8.GetPortionPercent());
	Percent12.SetPortionPercent(Percent8.GetPortionPercent());
}

void CVCDemoDlg::OnChangePercentctrl9() 
{
	Percent8.SetPortionPercent(Percent9.GetPortionPercent());
	Percent10.SetPortionPercent(Percent9.GetPortionPercent());
	Percent11.SetPortionPercent(Percent9.GetPortionPercent());
	Percent12.SetPortionPercent(Percent9.GetPortionPercent());
}

void CVCDemoDlg::OnChangePercentctrl10() 
{
	Percent8.SetPortionPercent(Percent10.GetPortionPercent());
	Percent9.SetPortionPercent(Percent10.GetPortionPercent());
	Percent11.SetPortionPercent(Percent10.GetPortionPercent());
	Percent12.SetPortionPercent(Percent10.GetPortionPercent());
}

void CVCDemoDlg::OnChangePercentctrl11() 
{
	Percent8.SetPortionPercent(Percent11.GetPortionPercent());
	Percent9.SetPortionPercent(Percent11.GetPortionPercent());
	Percent10.SetPortionPercent(Percent11.GetPortionPercent());
	Percent12.SetPortionPercent(Percent11.GetPortionPercent());
}

void CVCDemoDlg::OnChangePercentctrl12() 
{
	Percent8.SetPortionPercent(Percent12.GetPortionPercent());
	Percent9.SetPortionPercent(Percent12.GetPortionPercent());
	Percent10.SetPortionPercent(Percent12.GetPortionPercent());
	Percent11.SetPortionPercent(Percent12.GetPortionPercent());
}

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1010);
	KillTimer(1020);
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
int i;

	switch (nIDEvent) {
		case 1000: //fast multi portion timer
		    for (i=0;i<4;i++) {
				Percent1.SetPortionID(i);
				Percent1.SetPortionPercent(Percent1.GetPortionPercent() + (float) rand()/RAND_MAX * 2.0f - 1.0f);
				
				if (Percent1.GetPortionPercent() > 25.0f) 
					Percent1.SetPortionPercent(25.0f);
				if (Percent1.GetPortionPercent() < 0.0f) 
					Percent1.SetPortionPercent(0.0f);
				
				Percent2.SetPortionID(i);
				Percent2.SetPortionPercent(Percent1.GetPortionPercent());
				
				Percent3.SetPortionID(i);
				Percent3.SetPortionPercent(Percent1.GetPortionPercent());
				}
			
			break;
		case 1010: //fast file load timer
			Percent5.SetPortionPercent(Percent5.GetPortionPercent() + 3.0f * rand()/RAND_MAX);
			Percent6.SetPortionPercent(Percent5.GetPortionPercent());
			Percent7.SetPortionPercent(Percent5.GetPortionPercent());
			
			if (Percent5.GetPortionPercent() >= 100.0f) {
				KillTimer(1010);
				SetTimer(1020,2000,NULL);
				}
			
			break;
		case 1020: //slow file loader pause timer
			KillTimer(1020);
			
		    Percent5.SetPortionPercent(0.0f);
		    
			SetTimer(1010,55,NULL);
			break;
		}
	
	CDialog::OnTimer(nIDEvent);
}
